# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without          jbossas

%define version_full    0.9RC4

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/juddi/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section         free

# To make the tarball:
#  export CVSROOT=:pserver:anoncvs@cvs.apache.org:/home/cvspublic
#  cvs login (password: anoncvs)
#  cvs export -r juddi-0_9rc4 ws-juddi
#  find ws-juddi -name '*.jar' | xargs rm

%define basedir %{_localstatedir}/lib/%{name}
#%%define appdir %{basedir}/webapps
%define sqldir %{basedir}/sql
%define homedir %{_datadir}/%{name}

Name:           juddi
Version:        0.9
Release:        0.rc4.4%{?dist}
Epoch:          0
Summary:        Open source Java implementation UDDI specification
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://ws.apache.org/juddi/
Source0:        juddi-0.9rc4.tar.bz2
Source1:        juddi-component-info.xml
Patch0:         juddi-jdk5-enum.patch
#Optional:      axis
Requires:       jakarta-commons-logging
%if %with jbossas
#Optional:      jbossas
%endif
Requires:       tomcat5-servlet-2.4-api
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  axis
BuildRequires:  jakarta-commons-logging
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  tomcat5-servlet-2.4-api
%if %with jbossas
BuildRequires:  jbossas
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
jUDDI (pronounced "Judy") is an open source Java implementation 
of the Universal Description, Discovery, and Integration (UDDI) 
specification for Web Services.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%if 0
%package webapp
Summary:        Webapp for %{name}
Group:          System Environment/Applications
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jakarta-commons-discovery
Requires:       log4j
Requires:       wsdl4j

%description webapp
Webapp for %{name}.
%endif

%package sql-init-statements
Group:          Development/Libraries/Java
Summary:        SQL statements for database creation/configuration
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description sql-init-statements
SQL statements for creation/configuration of a database 
for storing web services metadata for %{name}.

%package apps
Group:          Development/Libraries/Java
Summary:        EAR file for jUDDI
#Requires:      %{name} = %{epoch}:%{version}-%{release}
Requires:       axis
Requires:       jakarta-commons-logging
Requires:       tomcat5-servlet-2.4-api

%description apps
The Enterprise Archive (ear) file for %{name}.

%package webapps
Group:          Development/Libraries/Java
Summary:        WAR file for jUDDI
#Requires:      %{name} = %{epoch}:%{version}-%{release}
Requires:       axis
Requires:       jakarta-commons-logging
Requires:       tomcat5-servlet-2.4-api

%description webapps
The Web Archive (war) file for %{name}.

%prep
%setup -q -n ws-juddi
%patch0 -p1
build-jar-repository -p -s lib \
    axis/axis \
    axis/jaxrpc \
    axis/saaj \
    jakarta-commons-logging \
%if %with jbossas
    jbossas/jbosssx-client \
%endif
    log4j \
    servletapi5 

%build
export OPT_JAR_LIST="junit ant/ant-junit"
export CLASSPATH=
ant ear javadoc test

%install
rm -rf $RPM_BUILD_ROOT

# *ars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/juddi
install -m 644 build/juddi.ear $RPM_BUILD_ROOT%{_javadir}/juddi/juddi-%{version}.ear
ln -s juddi-%{version}.ear $RPM_BUILD_ROOT%{_javadir}/juddi/juddi.ear

install -m 644 build/juddi.jar $RPM_BUILD_ROOT%{_javadir}/juddi/juddi-%{version}.jar
ln -s juddi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/juddi/juddi.jar

install -m 644 build/juddi.war $RPM_BUILD_ROOT%{_javadir}/juddi/juddi-%{version}.war
ln -s juddi-%{version}.war $RPM_BUILD_ROOT%{_javadir}/juddi/juddi.war

install -d -m 755 $RPM_BUILD_ROOT%{appdir}
install -d -m 755 $RPM_BUILD_ROOT%{sqldir}

%if 0
# webapps
cp -pr build/webapp/* $RPM_BUILD_ROOT%{appdir}
%endif

# sql
cp -pr sql/* $RPM_BUILD_ROOT%{sqldir}

# /usr/share/juddi
install -d -m 755 $RPM_BUILD_ROOT/%{homedir}
pushd $RPM_BUILD_ROOT%{homedir}
        [ -d webapps ] || ln -fs %{appdir} webapps
        [ -d sql ] || ln -fs %{sqldir} sql
popd

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/apiDocs/ $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_repolib}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version_full}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/juddi/juddi.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/juddi/juddi.war $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if 0
%post webapp
pushd %{appdir}/juddi/WEB-INF >& /dev/null
        build-jar-repository lib \
                axis/axis.jar \
                jakarta-commons-discovery.jar \
                jakarta-commons-logging.jar \
                log4j.jar \
                wsdl4j.jar
popd >& /dev/null

%preun webapp
rm -f %{appdir}/juddi/WEB-INF/lib/*.jar
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/juddi
%{_javadir}/juddi/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if 0
%files webapp
%defattr(0644,root,root,0755)
%{appdir}
%dir %{homedir}/webapps
%dir %{homedir}
%dir %{basedir}
%endif

%files sql-init-statements
%defattr(0644,root,root,0755)
%{sqldir}
%dir %{homedir}/sql
%dir %{homedir}
%dir %{basedir}

%files apps
%defattr(0644,root,root,0755)
%{_javadir}/juddi/*.ear

%files webapps
%defattr(0644,root,root,0755)
%dir %{homedir}/webapps
%{_javadir}/juddi/*.war

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Oct 08 2008 David Walluck <dwalluck@redhat.com> 0:0.9-0.rc4.4
- add optional jboss authenticator requirement
- add junit and log4j build requirements
- fix version and tag in component-info.xml
- fix repolib directory ownership
- fix repolib permissions
- use cp instead of mv in %%install so as to not break --short-circuit

* Thu May 29 2008 David Walluck <dwalluck@redhat.com> 0:0.9-0.rc4.3.jpp5
- fix License
- remove PreReq tag
- fix summary-ended-with-dot
- add /Java to all Group tags

* Fri May 02 2008 David Walluck <dwalluck@redhat.com> 0:0.9-0.rc4.2jpp.ep1.3
- patch for jdk5 enum
- own %%{_javadir}/juddi directory
- remove javadoc scriptlets

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:0.9-0.rc4.2jpp.ep1.2
- Fix repolib location

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com> 0:0.9-0.rc4.2jpp.ep1.1
- Make axis optional for juddi as it may be used in other containers

* Tue Feb 20 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:0.9-0.rc4.2jpp.el4ep1.2
- Add -brew suffix
- Export juddi.war in repolib

* Sat Feb 17 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:0.9-0.rc4.2jpp.el4ep1.1
- Add repolib support

* Wed Dec 07 2005 Fernando Nasser <fnasser@redhat.com> 0:0.9-0.rc4.2jpp_1rh
- Merge with upstream

* Wed Dec 07 2005 Fernando Nasser <fnasser@redhat.com> 0:0.9-0.rc4.2jpp
- First JPP 1.7 build

* Fri Jul 22 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp_3rh
- Removed the -b option from the patch directive as it is unnecessary.

* Thu Jul 21 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp_2rh
- Cleaned up spec file.
- Removed spurious dependency from apps and webapps on the main package.

* Tue Jul 19 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp_1rh
- First Red Hat build

* Mon Jul 18 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp
- Initial build.
